package processing.android.test;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.AdapterView.OnItemSelectedListener;

/**
 * 
 * NOTE: Examples must first be installed for this method to work.
 * 
 * If you don't have the Processing examples,
 * an alternative workaround is: 
 * move the ProcessingLauncher activity into the intended example's package (e.g. springs),
 * use this as the default package (rename in manifest, e.g. to processing.android.test.springs) and 
 * remove the package name from the intended launcher (e.g. to .Springs).
 * 
 * Remember to change this back if you wish to launch the other installed examples. 
 * 
 * -------------------
 * 
 * To add more examples
 * 
 * 1. copy source code to src in a package name processing.android.test.'example package name'
 * 2. (optional) copy any resources into assets
 * 3. add example name into res/values/examples.xml
 * 4. add example to AndroidManifest.xml
 * 
 * If you are creating a new project, remember to add processing-core.jar to the build path
 * 
 * @author norrielm
 * 
 * Visit http://dcs.gla.ac.uk/~norrielm/ for more sample code.
 *
 */
public class ProcessingLauncher extends Activity {

	String startExample = "Follow1"; //default
	
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        
       //start = this.getResources().getString(R.string.);
        
        ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(
	            this, R.array.examples, android.R.layout.simple_spinner_item);
	    adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		
        
        Spinner spinner = (Spinner)this.findViewById(R.id.examplespinner);
		spinner.setAdapter(adapter);
		spinner.setOnItemSelectedListener(new OnItemSelectedListener(){

			public void onItemSelected(AdapterView<?> parent,
			        View view, int pos, long id) {
				startExample = parent.getItemAtPosition(pos).toString();
			}

			public void onNothingSelected(AdapterView<?> arg0) {
				//nothing
			}
			
		});
        
        //set up the button with intended launcher
        Button b = (Button)this.findViewById(R.id.Button01);
        b.setText("Launch example");
        b.setOnClickListener(new OnClickListener(){
			public void onClick(View v) {
			    Intent intent = new Intent();
			    intent.setClassName(String.format("processing.android.test.%s", startExample.toLowerCase()), String.format("processing.android.test.%s.%s", startExample.toLowerCase(), startExample));
			    
			    try{
			    	startActivity(intent);
			    }catch(Exception e){
					AlertDialog.Builder a = new AlertDialog.Builder(ProcessingLauncher.this);
					a.setMessage("Example not installed or using workaround. \nSee ProcessingLauncher.java for details.")
							.setCancelable(true)
							.setNeutralButton("OK",
								new DialogInterface.OnClickListener() {
									public void onClick(DialogInterface dialog,
											int id) {
										dialog.cancel();
									}
							})
							;

					a.create();
					a.show();
			    }
			}
        });
        
        
    }
    
    
}